<template>
	<div class="row">
		<div
			class="col-12 col-sm-6 col-md-3"
			v-for="pokemon in pokemons"
			:key="pokemon.id"
		>
			<card-preview :pokemon="pokemon" class="q-ma-md" />
		</div>
		<div class="q-pa-lg q-my-lg col-12 flex flex-center">
			<q-pagination
				ref="pagination"
				:size="$q.screen.gt.sm ? '16px' : '12px'"
				boundary-numbers
				:max-pages="$q.screen.gt.sm ? 10 : 3"
				v-model="currentPage"
				@input="updatePage"
				color="deep-orange"
				:max="totalPages"
				boundary-links
				direction-links
			/>
		</div>
	</div>
</template>

<script>
	import { mapActions, mapGetters, mapMutations, mapState } from "vuex";
	import headerTitle from "src/components/typography/header-title.vue";
	import CardPreview from "src/components/pokemon/CardPreview.vue";
	export default {
		name: "PaginateViewing",
		components: {
			headerTitle,
			CardPreview,
		},
		data: () => ({
			currentPage: 1,
		}),

		methods: {
			...mapActions("pokemon", ["fetchData"]),
			...mapMutations("pokemon", ["toggleLoading", "clearPokemon"]),

			async updatePage(val) {
				this.$q.loading.show();

				//formula for offseting api

				let offset = (val - 1) * 8;

				await this.fetchData({
					url: `pokemon?offset=${offset}&limit=8`,
					type: "pagination",
				});

				this.$q.loading.hide();
			},
		},

		computed: {
			...mapGetters("pokemon", ["pokemons"]),
			...mapState("pokemon", ["urlApi", "totalPokemons", "loading"]),

			totalPages() {
				return Math.ceil(1118 / 8);
			},
		},
	};
</script>

<style>
</style>